# wxFrame Class Reference
[Managed Windows]

`#include <wx/frame.h>`

Inheritance diagram for wxFrame:
[legend]

## Detailed Description

A frame is a window whose size and position can (usually) be changed by the user.

It usually has thick borders and a title bar, and can optionally contain a menu bar, toolbar and status bar. A frame can contain any window that is not a frame or dialog.

A frame that has a status bar and toolbar, created via the CreateStatusBar() and CreateToolBar() functions, manages these windows and adjusts the value returned by GetClientSize() to reflect the remaining size available to application windows.

Remarks:
  An application should normally define an wxCloseEvent handler for the frame to respond to system close events, for example so that related data and subwindows can be cleaned up.

## Default event processing

wxFrame processes the following events:

- `wxEVT_SIZE:` if the frame has exactly one child window, not counting the status and toolbar, this child is resized to take the entire frame client area. If two or more windows are present, they should be laid out explicitly either by manually handling `wxEVT_SIZE` or using sizers;
- `wxEVT_MENU_HIGHLIGHT:` the default implementation displays the help string associated with the selected item in the first pane of the status bar, if there is one.

## Styles

This class supports the following styles:

- wxDEFAULT_FRAME_STYLE:
  Defined as wxMINIMIZE_BOX | wxMAXIMIZE_BOX | wxRESIZE_BORDER | wxSYSTEM_MENU | wxCAPTION | wxCLOSE_BOX | wxCLIP_CHILDREN.
- wxICONIZE:
  Display the frame iconized (minimized). Windows only.
- wxCAPTION:
  Puts a caption on the frame. Notice that this flag is required by wxMINIMIZE_BOX, wxMAXIMIZE_BOX and wxCLOSE_BOX on most systems as the corresponding buttons cannot be shown if the window has no title bar at all. I.e. if wxCAPTION is not specified those styles would be simply ignored.
- wxMINIMIZE:
  Identical to wxICONIZE. Windows only.
- wxMINIMIZE_BOX:
  Displays a minimize box on the frame.
- wxMAXIMIZE:
  Displays the frame maximized. Windows and GTK+ only.
- wxMAXIMIZE_BOX:
  Displays a maximize box on the frame. Notice that under wxGTK wxRESIZE_BORDER must be used as well or this style is ignored.
- wxCLOSE_BOX:
  Displays a close box on the frame.
- wxSTAY_ON_TOP:
  Stay on top of all other windows, see also wxFRAME_FLOAT_ON_PARENT.
- wxSYSTEM_MENU:
  Displays a system menu containing the list of various windows commands in the window title bar. Unlike wxMINIMIZE_BOX, wxMAXIMIZE_BOX and wxCLOSE_BOX styles this style can be used without wxCAPTION, at least under Windows, and makes the system menu available without showing it on screen in this case. However it is recommended to only use it together with wxCAPTION for consistent behaviour under all platforms.
- wxRESIZE_BORDER:
  Displays a resizable border around the window.
- wxFRAME_TOOL_WINDOW:
  Causes a frame with a small title bar to be created; the frame does not appear in the taskbar under Windows or GTK+.
- wxFRAME_NO_TASKBAR:
  Creates an otherwise normal frame but it does not appear in the taskbar under Windows or GTK+ (note that it will minimize to the desktop window under Windows which may seem strange to the users and thus it might be better to use this style only without wxMINIMIZE_BOX style). In wxGTK, the flag is respected only if the window manager supports _NET_WM_STATE_SKIP_TASKBAR hint.
- wxFRAME_FLOAT_ON_PARENT:
  The frame will always be on top of its parent (unlike wxSTAY_ON_TOP). A frame created with this style must have a non-NULL parent.
- wxFRAME_SHAPED:
  Windows with this style are allowed to have their shape changed with the SetShape() method.

The default frame style is for normal, resizable frames. To create a frame which cannot be resized by user, you may use the following combination of styles:

            wxDEFAULT_FRAME_STYLE & ~(wxRESIZE_BORDER | wxMAXIMIZE_BOX)

See also the Window Styles.

## Extra styles

This class supports the following extra styles:

- wxFRAME_EX_CONTEXTHELP:
  Under Windows, puts a query button on the caption. When pressed, Windows will go into a context-sensitive help mode and wxWidgets will send a `wxEVT_HELP` event if the user clicked on an application window. Note that this is an extended style and must be set by calling SetExtraStyle before Create is called (two-step construction). You cannot use this style together with wxMAXIMIZE_BOX or wxMINIMIZE_BOX, so you should use wxDEFAULT_FRAME_STYLE ~ (wxMINIMIZE_BOX | wxMAXIMIZE_BOX) for the frames having this style (the dialogs don't have a minimize or a maximize box by default)
- wxFRAME_EX_METAL:
  On Mac OS X, frames with this style will be shown with a metallic look. This is an extra style.

## Events emitted by this class

Event macros for events emitted by this class:

- EVT_CLOSE(func):
  The frame is being closed by the user or programmatically (see wxWindow::Close). The user may generate this event clicking the close button (typically the 'X' on the top-right of the title bar) if it's present (see the `wxCLOSE_BOX` style). See wxCloseEvent.
- EVT_ICONIZE(func):
  Process a `wxEVT_ICONIZE` event. See wxIconizeEvent.
- EVT_MENU_OPEN(func):
  A menu is about to be opened. See wxMenuEvent.
- EVT_MENU_CLOSE(func):
  A menu has been just closed. See wxMenuEvent.
- EVT_MENU_HIGHLIGHT(id, func):
  The menu item with the specified id has been highlighted: used to show help prompts in the status bar by wxFrame. See wxMenuEvent.
- EVT_MENU_HIGHLIGHT_ALL(func):
  A menu item has been highlighted, i.e. the currently selected menu item has changed. See wxMenuEvent.

##

Library: wxCore

Category: Managed Windows

See also:
  wxMDIParentFrame, wxMDIChildFrame, wxMiniFrame, wxDialog

## Public Member Functions
| wxFrame ()
| Default constructor.
| wxFrame (wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxDEFAULT_FRAME_STYLE, const wxString &name=wxFrameNameStr)
| Constructor, creating the window.
virtual | ~wxFrame ()
| Destructor.
void | Centre (int direction=wxBOTH)
| Centres the frame on the display.
bool | Create (wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxDEFAULT_FRAME_STYLE, const wxString &name=wxFrameNameStr)
| Used in two-step frame construction.
virtual wxStatusBar * | CreateStatusBar (int number=1, long style=wxSTB_DEFAULT_STYLE, wxWindowID id=0, const wxString &name=wxStatusLineNameStr)
| Creates a status bar at the bottom of the frame.
virtual wxToolBar * | CreateToolBar (long style=wxBORDER_NONE|wxTB_HORIZONTAL, wxWindowID id=wxID_ANY, const wxString &name=wxToolBarNameStr)
| Creates a toolbar at the top or left of the frame.
virtual wxPoint | GetClientAreaOrigin () const
| Returns the origin of the frame client area (in client coordinates).
virtual wxMenuBar * | GetMenuBar () const
| Returns a pointer to the menubar currently associated with the frame (if any).
virtual wxStatusBar * | GetStatusBar () const
| Returns a pointer to the status bar currently associated with the frame (if any).
int | GetStatusBarPane () const
| Returns the status bar pane used to display menu and toolbar help.
virtual wxToolBar * | GetToolBar () const
| Returns a pointer to the toolbar currently associated with the frame (if any).
virtual wxStatusBar * | OnCreateStatusBar (int number, long style, wxWindowID id, const wxString &name)
| Virtual function called when a status bar is requested by CreateStatusBar().
virtual wxToolBar * | OnCreateToolBar (long style, wxWindowID id, const wxString &name)
| Virtual function called when a toolbar is requested by CreateToolBar().
bool | ProcessCommand (int id)
| Simulate a menu command.
virtual void | SetMenuBar (wxMenuBar *menuBar)
| Tells the frame to show the given menu bar.
virtual void | SetStatusBar (wxStatusBar *statusBar)
| Associates a status bar with the frame.
void | SetStatusBarPane (int n)
| Set the status bar pane used to display menu and toolbar help.
virtual void | SetStatusText (const wxString &text, int number=0)
| Sets the status bar text and redraws the status bar.
virtual void | SetStatusWidths (int n, const int *widths_field)
| Sets the widths of the fields in the status bar.
virtual void | SetToolBar (wxToolBar *toolBar)
| Associates a toolbar with the frame.
void | PushStatusText (const wxString &text, int number=0)
void | PopStatusText (int number=0)

List of all members.

## Constructor & Destructor Documentation

wxFrame::wxFrame | ( |  | ) |

Default constructor.

wxFrame::wxFrame | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxString & | title,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxDEFAULT_FRAME_STYLE`,
|  | const wxString & | name = `wxFrameNameStr` |
| ) |  |  |

Constructor, creating the window.

Parameters:

  | parent | The window parent. This may be NULL. If it is non-NULL, the frame will always be displayed on top of the parent window on Windows.
  | id | The window identifier. It may take a value of -1 to indicate a default value.
  | title | The caption to be displayed on the frame's title bar.
  | pos | The window position. The value wxDefaultPosition indicates a default position, chosen by either the windowing system or wxWidgets, depending on platform.
  | size | The window size. The value wxDefaultSize indicates a default size, chosen by either the windowing system or wxWidgets, depending on platform.
  | style | The window style. See wxFrame class description.
  | name | The name of the window. This parameter is used to associate a name with the item, allowing the application user to set Motif resource values for individual windows.

Remarks:
  For Motif, MWM (the Motif Window Manager) should be running for any window styles to work (otherwise all styles take effect).

See also:
  Create()

virtual wxFrame::~wxFrame | ( |  | ) | `[virtual]`

Destructor.

Destroys all child windows and menu bar if present.

See Window Deletion for more info.

## Member Function Documentation

void wxFrame::Centre | ( | int | direction = `wxBOTH` | ) |

Centres the frame on the display.

Parameters:

  | direction | The parameter may be wxHORIZONTAL, wxVERTICAL or wxBOTH.

Reimplemented from wxWindow.

bool wxFrame::Create | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxString & | title,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxDEFAULT_FRAME_STYLE`,
|  | const wxString & | name = `wxFrameNameStr` |
| ) |  |  |

Used in two-step frame construction.

See wxFrame() for further details.

Reimplemented from wxTopLevelWindow.

Reimplemented in wxMDIParentFrame, and wxMiniFrame.

virtual wxStatusBar* wxFrame::CreateStatusBar | ( | int | number = `1`,
|  | long | style = `wxSTB_DEFAULT_STYLE`,
|  | wxWindowID | id = `0`,
|  | const wxString & | name = `wxStatusLineNameStr` |
| ) |  |  | `[virtual]`

Creates a status bar at the bottom of the frame.

Parameters:

  | number | The number of fields to create. Specify a value greater than 1 to create a multi-field status bar.
  | style | The status bar style. See wxStatusBar for a list of valid styles.
  | id | The status bar window identifier. If -1, an identifier will be chosen by wxWidgets.
  | name | The status bar window name.

Returns:
  A pointer to the status bar if it was created successfully, NULL otherwise.

Remarks:
  The width of the status bar is the whole width of the frame (adjusted automatically when resizing), and the height and text size are chosen by the host windowing system.

See also:
  SetStatusText(), OnCreateStatusBar(), GetStatusBar()

virtual wxToolBar* wxFrame::CreateToolBar | ( | long | style = `wxBORDER_NONE|wxTB_HORIZONTAL`,
|  | wxWindowID | id = `wxID_ANY`,
|  | const wxString & | name = `wxToolBarNameStr` |
| ) |  |  | `[virtual]`

Creates a toolbar at the top or left of the frame.

Parameters:

  | style | The toolbar style. See wxToolBar for a list of valid styles.
  | id | The toolbar window identifier. If -1, an identifier will be chosen by wxWidgets.
  | name | The toolbar window name.

Returns:
  A pointer to the toolbar if it was created successfully, NULL otherwise.

Remarks:
  By default, the toolbar is an instance of wxToolBar. To use a different class, override OnCreateToolBar(). When a toolbar has been created with this function, or made known to the frame with wxFrame::SetToolBar(), the frame will manage the toolbar position and adjust the return value from wxWindow::GetClientSize() to reflect the available space for application windows. Under Pocket PC, you should always use this function for creating the toolbar to be managed by the frame, so that wxWidgets can use a combined menubar and toolbar. Where you manage your own toolbars, create a wxToolBar as usual.

See also:
  CreateStatusBar(), OnCreateToolBar(), SetToolBar(), GetToolBar()

virtual wxPoint wxFrame::GetClientAreaOrigin | ( |  | ) | const`[virtual]`

Returns the origin of the frame client area (in client coordinates).

It may be different from (0, 0) if the frame has a toolbar.

Reimplemented from wxWindow.

virtual wxMenuBar* wxFrame::GetMenuBar | ( |  | ) | const`[virtual]`

Returns a pointer to the menubar currently associated with the frame (if any).

See also:
  SetMenuBar(), wxMenuBar, wxMenu

virtual wxStatusBar* wxFrame::GetStatusBar | ( |  | ) | const`[virtual]`

Returns a pointer to the status bar currently associated with the frame (if any).

See also:
  CreateStatusBar(), wxStatusBar

int wxFrame::GetStatusBarPane | ( |  | ) | const

Returns the status bar pane used to display menu and toolbar help.

See also:
  SetStatusBarPane()

virtual wxToolBar* wxFrame::GetToolBar | ( |  | ) | const`[virtual]`

Returns a pointer to the toolbar currently associated with the frame (if any).

See also:
  CreateToolBar(), wxToolBar, SetToolBar()

virtual wxStatusBar* wxFrame::OnCreateStatusBar | ( | int | number,
|  | long | style,
|  | wxWindowID | id,
|  | const wxString & | name |
| ) |  |  | `[virtual]`

Virtual function called when a status bar is requested by CreateStatusBar().

Parameters:

  | number | The number of fields to create.
  | style | The window style. See wxStatusBar for a list of valid styles.
  | id | The window identifier. If -1, an identifier will be chosen by wxWidgets.
  | name | The window name.

Returns:
  A status bar object.

Remarks:
  An application can override this function to return a different kind of status bar. The default implementation returns an instance of wxStatusBar.

See also:
  CreateStatusBar(), wxStatusBar.

virtual wxToolBar* wxFrame::OnCreateToolBar | ( | long | style,
|  | wxWindowID | id,
|  | const wxString & | name |
| ) |  |  | `[virtual]`

Virtual function called when a toolbar is requested by CreateToolBar().

Parameters:

  | style | The toolbar style. See wxToolBar for a list of valid styles.
  | id | The toolbar window identifier. If -1, an identifier will be chosen by wxWidgets.
  | name | The toolbar window name.

Returns:
  A toolbar object.

Remarks:
  An application can override this function to return a different kind of toolbar. The default implementation returns an instance of wxToolBar.

See also:
  CreateToolBar(), wxToolBar.

void wxFrame::PopStatusText | ( | int | number = `0` | ) |

bool wxFrame::ProcessCommand | ( | int | id | ) |

Simulate a menu command.

Parameters:

  | id | The identifier for a menu item.

void wxFrame::PushStatusText | ( | const wxString & | text,
|  | int | number = `0` |
| ) |  |  |

virtual void wxFrame::SetMenuBar | ( | wxMenuBar * | menuBar | ) | `[virtual]`

Tells the frame to show the given menu bar.

Parameters:

  | menuBar | The menu bar to associate with the frame.

Remarks:
  If the frame is destroyed, the menu bar and its menus will be destroyed also, so do not delete the menu bar explicitly (except by resetting the frame's menu bar to another frame or NULL). Under Windows, a size event is generated, so be sure to initialize data members properly before calling SetMenuBar(). Note that on some platforms, it is not possible to call this function twice for the same frame object.

See also:
  GetMenuBar(), wxMenuBar, wxMenu.

virtual void wxFrame::SetStatusBar | ( | wxStatusBar * | statusBar | ) | `[virtual]`

Associates a status bar with the frame.

If statusBar is NULL, then the status bar, if present, is detached from the frame, but not deleted.

See also:
  CreateStatusBar(), wxStatusBar, GetStatusBar()

void wxFrame::SetStatusBarPane | ( | int | n | ) |

Set the status bar pane used to display menu and toolbar help.

Using -1 disables help display.

virtual void wxFrame::SetStatusText | ( | const wxString & | text,
|  | int | number = `0` |
| ) |  |  | `[virtual]`

Sets the status bar text and redraws the status bar.

Parameters:

  | text | The text for the status field.
  | number | The status field (starting from zero).

Remarks:
  Use an empty string to clear the status bar.

See also:
  CreateStatusBar(), wxStatusBar

virtual void wxFrame::SetStatusWidths | ( | int | n,
|  | const int * | widths_field |
| ) |  |  | `[virtual]`

Sets the widths of the fields in the status bar.

Parameters:

  | n | The number of fields in the status bar. It must be the same used in CreateStatusBar.
  | widths_field | Must contain an array of n integers, each of which is a status field width in pixels. A value of -1 indicates that the field is variable width; at least one field must be -1. You should delete this array after calling SetStatusWidths().

Remarks:
  The widths of the variable fields are calculated from the total width of all fields, minus the sum of widths of the non-variable fields, divided by the number of variable fields.

wxPerl Note: In wxPerl this method takes the field widths as parameters.

virtual void wxFrame::SetToolBar | ( | wxToolBar * | toolBar | ) | `[virtual]`

Associates a toolbar with the frame.

|  | [ top ]